Ruby - Bug #17503

Typing an invalid percent string crashes irb

01/03/2021 11:43 AM - niconii (Nicolette Verlinden)

Status:
Priority:

Assignee:

Target version:

Closed

Normal

ruby -v: ruby 3.0.0p0 (2020-12-25 revision Backport: 2.5: UNKNOWN, 2.6: UNKNOWN, 2.7:
95aff21468) [x86_64-linux] UNKNOWN
Description
1. Start irb.

2. Try typing in %abc. Keep typing in alphanumeric characters if it hasn't crashed yet.

3. irb crashes with the following error message:

/usr/local/lib/ruby/3.0.0/reline/unicode.rb:124:in "calculate_width': undefined method “encode' fo
r nil:NilClass (NoMethodError)
.0/forwardable.rb:238:in ‘readmultiline'’
.0/forwardable.rb:238:in ‘readmultiline'’
.0/irb/input-method.rb:302:in “gets'

.0/irb.rb:519:1in
.0/irb.rb:721:in 'signal_status'
.0/irb.rb:518:in
.0/irb/ruby-lex.
.0/irb/ruby-lex.
.0/reline/line_editor.rb:1314:in “calculate_width'
.0/reline/line_editor.rb:126:in "“check_multiline_prompt'
.0/reline/line_editor.rb:365:in "rerender'

.0/reline.
.0/reline.
.0/reline.

n “block (3 levels) in inner_readline'
n “each'

n "block (2 levels) in inner_readline'
n ‘block in read_io'

n " loop'

n “read_io'

n "block in inner_readline'
n " loop'

n “inner_readline'

n ‘readmultiline'

block (2 levels) in eval_input'

block in eval_input'
202:in "~ lex'
174:in "block (2 levels) in each_top_level_

/usr/local/lib/ruby/3.0.0/irb/ruby-lex.rb:171:in " loop"
/usr/local/lib/ruby/3.0.0/irb/ruby-lex.rb:171:in ‘block in each_top_level_statement'
/usr/local/lib/ruby/3.0.0/irb/ruby-lex.rb:170:in ‘catch’
/usr/local/lib/ruby/3.0.0/irb/ruby-lex.rb:170:in “each_top_level_statement'
/usr/local/lib/ruby/3.0.0/irb.rb:537:in “eval_input'
/usr/local/lib/ruby/3.0.0/irb.rb:472:in “block in run'
/usr/local/lib/ruby/3.0.0/irb.rb:471:in “catch'
/usr/local/lib/ruby/3.0.0/irb.rb:471:in “run'
/usr/local/lib/ruby/3.0.0/irb.rb:400:in " start'
/usr/local/lib/ruby/gems/3.0.0/gems/irb-1.3.0/exe/irb:11:in "“<top (required)>"'
/usr/local/bin/irb:23:in " load'

/usr/local/bin/irb:23:in " <main>"'

History

#1 - 01/03/2021 12:15 PM - pocke (Masataka Kuwabara)
https://github.com/ruby/irb/issues/162

Probably | met the same problem and | reported it as the issue.

#2 - 01/05/2021 06:55 PM - aycabta (aycabta .)

- Status changed from Open to Closed
https://github.com/ruby/irb/issues/162

Thank you for the reporting. This is fixed by https://github.com/ruby/irb/pull/163.
